var nFinalHeight = 50;
var nSlideIncrement = 1;
var nSlideTime = 10;
var nOpenTime = 3000; // total time the message should stay up once we are done animating.

var oMessageListener = null;
var bMessageTextClickable = false;
var cMessageCookie = "";

var n_MAX_HEIGHT = 200;

var allowClose = true;

function prefillInfo() {
  if ("arguments" in window && window.arguments.length > 0) {
    var text = document.getElementById("message-text")
    var value = window.arguments[0];
    text.value = value;

    // find out how long the longest word in the text is, if more than 25, in 5 character increments
    for (var i = 25;value.match(RegExp("[^ \\t\\n\\r]{" + i + "}")) != null; i += 5) {};

    text.setAttribute("cols", i);
    text.setAttribute("rows", Math.floor(value.length/i)); // this could be 0 if it was a short message but it seems to have a builtin check against going < 1, so I'll let it handle that
  }
}

function onLoad() {
  // read out our initial settings from prefs.
  try {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService();
    prefService = prefService.QueryInterface(Components.interfaces.nsIPrefService);
    var prefBranch = prefService.getBranch(null);
    nSlideIncrement = prefBranch.getIntPref("alerts.slideIncrement");
    nSlideTime = prefBranch.getIntPref("alerts.slideIncrementTime");
    nOpenTime = prefBranch.getIntPref("alerts.totalOpenTime");
  } catch (ex) {}

  sizeToContent();

  nFinalHeight = window.outerHeight;  //134  5 lines - 152 6 lines
  if ( nFinalHeight > n_MAX_HEIGHT ) {
    nFinalHeight = n_MAX_HEIGHT;
  }

  window.outerHeight = 1;

  // offseting the message by 10 pixels from the right edge & 36 from the bottom
  window.moveTo( (screen.availLeft + screen.availWidth - window.outerWidth) - 10, (screen.availTop + screen.availHeight - window.outerHeight) - 36);
  setTimeout(animateMessage, nSlideTime);
}

function animateMessage() {
  if (window.outerHeight < nFinalHeight) {
    window.screenY -= nSlideIncrement;
    window.outerHeight += nSlideIncrement;
    setTimeout(animateMessage, nSlideTime);
  } else {
    setTimeout(closeMessage, nOpenTime);
  }
}

function closeMessage() {
  if (allowClose) {
    if (window.outerHeight > 1) {
      window.screenY += nSlideIncrement;
      window.outerHeight -= nSlideIncrement;
      setTimeout(closeMessage, nSlideTime);
    } else {
      if (oMessageListener) {
        oMessageListener.observe(null, "alertfinished", cMessageCookie);
      }
      window.close(); 
    }
  }
}

function onMessageClick(evt, item) {
  if (evt.button == 0 && item.id == "webtag-message") { // left click only
    allowClose = !allowClose;
    if (allowClose) {
      closeMessage();
    } else {
      animateMessage();
    }
  }
  inContextMenu = false;
}
